﻿//########################
//InDesignCS3に画像を配置していきます。
//右ページ、左ページ個別にフレームサイズを指定する事ができ、
//さらにPDFの配置時のフィット方法も右ページ、左ページ個別に設定できます。
//ドキュメントを開いて実行してください。
//たけうちとおる
//########################


//ダイアログ表示のおまじない
app.scriptPreferences.userInteractionLevel=1699311169;
////////下記が初期値になりますので編集してください。//////////
//配置スタートページ
var startpage = 1;
//塗りたし天
var l_ten = 3;
//塗りたし地
var l_chi = 3;
//塗りたし左
var l_left = 3;
//塗りたし右
var l_right = 3;
//左ページPDFの水平パーセント
var l_myPerW = 100;
//左ページPDFの垂直パーセント
var l_myPerH = 100;
//左ページPDF配置オプション　比率を指定してセンター=0　内容をフレームに合わせる=1　内容を縦横比率に応じて合わせる（短辺）=2　フレームに均等に流し込む（長辺）
var l_pdf_fitopt = 0;

main();
function main(){
	if (app.documents.length == 0){
			alert("ドキュメントを開いて実行してください。");
			return;
	}
	//ダイアログを作成する
	var mypt = 2.83465;
	myDialog = app.dialogs.add({name:"画像をInDesignに配置します。"});
	with(myDialog){
		with(dialogColumns.add()){
			with(borderPanels.add()){
				with (dialogColumns.add()){
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"配置スタートページ"});
						var d_startpage = integerEditboxes.add({editValue:startpage,minimumValue:1,maximumValue:1000});
					}
				}
			}
			with(borderPanels.add()){
				with (dialogColumns.add()){
					staticTexts.add({staticLabel:"塗り足し"});
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"　天"});
						var d_l_ten = measurementEditboxes.add({editUnits:MeasurementUnits.millimeters, editValue:l_ten *mypt,minimumValue:-1000*mypt,maximumValue:1000*mypt});
						staticTexts.add({staticLabel:"　地"});
						var d_l_chi = measurementEditboxes.add({editUnits:MeasurementUnits.millimeters, editValue:l_chi*mypt,minimumValue:-1000*mypt,maximumValue:1000*mypt});
					}
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"左"});
						var d_l_left = measurementEditboxes.add({editUnits:MeasurementUnits.millimeters, editValue:l_left *mypt,minimumValue:-1000*mypt,maximumValue:1000*mypt});
						staticTexts.add({staticLabel:"右"});
						var d_l_right = measurementEditboxes.add({editUnits:MeasurementUnits.millimeters, editValue:l_right *mypt,minimumValue:-1000*mypt,maximumValue:1000*mypt});
					}
				}
			}
			with(borderPanels.add()){
				with (dialogColumns.add()){
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"配置方法"});
					}
					with (dialogRows.add()){
						var Listpdfplaceopt = new Array("比率を指定してセンター", "内容をフレームに合わせる", "内容を縦横比率に応じて合わせる（短辺）","フレームに均等に流し込む（長辺）");
						var d_l_pdf_fitopt = dropdowns.add({stringList:Listpdfplaceopt, selectedIndex:l_pdf_fitopt, minWidth:120});
					}
					with (dialogRows.add()){
						var Listpercent = new Array("100", "90", "80", "70", "60", "50", "40", "30", "20", "10", "0");
						staticTexts.add({staticLabel:"Wの変倍率"});
						var d_l_myPerW = percentComboboxes.add({editValue:l_myPerW,minimumValue:0,maximumValue:1000,stringList:Listpercent});
					}
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"Hの変倍率"});
						var d_l_myPerH = percentComboboxes.add({editValue:l_myPerH,minimumValue:0,maximumValue:1000,stringList:Listpercent});
					}
				}
			}
			staticTexts.add({staticLabel:"(C)2009 Toru Takeuchi このスクリプトはフリーウェアです。"});
		}
	}
	var myReturn = myDialog.show();
	//ここから処理を行う
	if (myReturn == true){
		startpage = d_startpage.editValue;
		l_ten = d_l_ten.editValue/mypt;
		l_chi = d_l_chi.editValue/mypt;
		l_left = d_l_left.editValue/mypt;
		l_right = d_l_right.editValue/mypt;
//
		l_myPerW = d_l_myPerW.editValue;
		l_myPerH = d_l_myPerH.editValue;
		l_pdf_fitopt = d_l_pdf_fitopt.selectedIndex;
		
		myDialog.destroy();
		indd_select_img();
	}
	else{
		myDialog.destroy();
	}
}

function indd_select_img(){
	if (app.documents.length != 0){
		var placepage = startpage;
		var folderObj = getfolder()
		fileList = folderObj.getFiles();
		for(var N=0;N<fileList.length;N++){
			var selFile = fileList[N];
			if(selFile.hidden == false){
				placeimg(selFile,placepage)
				placepage++;
			}
		}
	}
}
//フォルダ選択ダイアログ
function getfolder(){
	var folderobj = Folder.selectDialog("画像が入ったフォルダを選択してください");
	return folderobj;
}
function placeimg(selFile,placepage){
	if(app.activeDocument.pages.length < placepage){
		var pageObj = app.activeDocument.pages.add();
	}else{
		var pageObj = app.activeDocument.pages[placepage-1];
	}
	var rectObj = pageObj.rectangles.add();
	rectObj.strokeWeight = 0;
	var rectbounds = pageObj.bounds;
	//[Y1,X1,Y2,X2]
	rectbounds[0]=rectbounds[0]-l_ten;
	rectbounds[1]=rectbounds[1]-l_left;
	rectbounds[2]=rectbounds[2]+l_chi;
	rectbounds[3]=rectbounds[3]+l_right;
	rectObj.geometricBounds = rectbounds;
	var pdfobj = rectObj.place(selFile);
	rectObj.allGraphics[0].verticalScale = l_myPerH;
	rectObj.allGraphics[0].horizontalScale = l_myPerW;

	//var Listpdfplaceopt = new Array("比率を指定してセンター", "内容をフレームに合わせる", "内容を縦横比率に応じて合わせる（短辺）","フレームに均等に流し込む（長辺）");
	if(l_pdf_fitopt == 0){
		var myfitopt = FitOptions.CENTER_CONTENT;
	}else if(l_pdf_fitopt == 1){
		var myfitopt = FitOptions.CONTENT_TO_FRAME;
	}else if(l_pdf_fitopt == 2){
		var myfitopt = FitOptions.PROPORTIONALLY;
	}else if(l_pdf_fitopt == 3){
		var myfitopt = FitOptions.FILL_PROPORTIONALLY;
	}
	rectObj.fit (myfitopt);
	rectObj.fit (FitOptions.CENTER_CONTENT);
	return true;
}